//used for saving and loading configuration data
unit SuppletOpts;

interface

uses windows,controls,sysutils,registry,myDialogs,textdata;

//type

function loadOwner(lang:integer):String;
procedure saveOwner(what:String);
function loadOnlinehelp:String;
function getInstallLocation:String;
function getConfigLocation:String;
procedure resetOptions;
function loadButton(what:integer):integer;
procedure saveButton(what: integer; val:integer);
function loadMarkerStyle(what:string):MarkerStyle;
procedure saveMarkerStyle(what:string;style:MarkerStyle);
function loadNoteStyle(what:string):NoteStyle;
procedure saveNoteStyle(what:string;style:NoteStyle);
function loadHelpFile:string;
procedure saveHelpFile(path:string);
function loadMemPath:string;
procedure saveMemPath(path:string);
procedure saveLanguage(what:integer);
function loadLanguage:integer;

procedure makereadme(temp:string);

const
  True: wordbool=(1=1);
  False:wordbool=(1=2);

  WM_UPDATEOPTIONS='Supplets Configuration Updated';
  Class_bar: TGUID =   '{A7AF8533-1047-46FD-9745-CE9B0E2B45D9}';
  Class_Config:TGUID = '{8165030E-40EA-4D3E-B51C-B94616586954}';
  Class_marker: TGUID ='{0EC90553-9F39-4817-9F60-4231BE049C18}';

  ExtensionsPath='\Software\Microsoft\Internet Explorer\Extensions';

  browserhelperobjects = '\Software\Microsoft\Windows\CurrentVersion\explorer\Browser Helper Objects';
  verticalBarCatID='Implemented Categories\{00021493-0000-0000-C000-000000000046}';
  BarPath='\Software\Microsoft\Internet Explorer\Explorer Bars';
  ConfigPath='\ConfigData';

implementation

uses
//just temporary for debug:
  Dialogs, Messages,
  ActiveX, ComObj, ComServ,Forms;

procedure saveReg(key:string;val:string);
var
	S: string;
	Reg: TRegistry;
begin
	S := GUIDToString(Class_marker);
	Reg := TRegistry.Create;
     try
	Reg.RootKey := HKEY_CURRENT_USER;
	Reg.OpenKey(barPath + '\' + S + CONFIGPATH,true);
        Reg.WriteString(key,val);
        Reg.CloseKey;
     finally
        Reg.Free;
     end;
end; // saveReg

function loadReg(key:string):string;
var
	S: string;
	Reg: TRegistry;
begin
Result:='';
	S := GUIDToString(Class_marker);
	Reg := TRegistry.Create;
     try
      try
	Reg.RootKey := HKEY_CURRENT_USER;
	Reg.OpenKey(barPath + '\' + S + CONFIGPATH,true);
        Result:=Reg.ReadString(key);
        Reg.CloseKey;
       except
       Result:='';
       end;
     finally
        Reg.Free;
     end;
end; // loadReg

function loadOwner(lang:integer):String;
var
temp:string;
tempx:PChar;
size:dword;
begin
temp:=loadreg('username');
if(temp='')then
  begin
  getmem(tempX,1023);
  size:=1022;
  getusername(tempX,size);
  temp:=tempx;
  temp:=inputbox(loadLangRes(114+lang),loadLangRes(115+lang),temp);
  saveOwner(temp);
  freemem(tempX);
  end;
result:=temp;
end;

procedure saveOwner(what:String);
begin
savereg('username',what);
end;

procedure makereadme(temp:string);
var
readme:textfile;

  begin
  AssignFile(readme,temp+'\readme.txt');
  Rewrite(readme);
  writeln(readme,'This folder contains the memory of your supplets plugin.');
  writeln(readme,'Those html files can be opened in every Browser.');
  writeln(readme,'If you delete part of the files or the whole folder the annotations on the corresponding web pages are lost');
  CloseFile(readme);
  end;

function loadMemPath:string;
var
temp:string;
Reg: TRegistry;
test:array[0..255]of char;
begin
temp:=loadReg('MemoryPath');
//MessageDlg('savedir2: '+temp,mtInformation,[mbOk], 0);
if(temp<>'')then
  begin
  try
  StrPCopy(test,temp);
  if(not(SetCurrentDirectory(test)))then
    temp:='';
  except
  temp:='';
  end;
  end;
if(temp='')then
  begin
	Reg := TRegistry.Create;
     try
	Reg.RootKey := HKEY_CURRENT_USER;
	Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',false);
        temp:=Reg.ReadString('Personal');
        Reg.CloseKey;
     finally
        Reg.Free;
     end;
     temp:=temp+'\Supplets';
     StrPCopy(test,temp);
     if(not(SetCurrentDirectory(test)))then
       begin
       if(not(CreateDirectory(test,nil)))then
         temp:=''
       else
         saveMemPath(temp);
       end
     else
       saveMemPath(temp);
  end;
//MessageDlg('savedir3: '+temp,mtInformation,[mbOk], 0);
if(temp<>'')and(not(fileexists(temp+'\readme.txt')))then
  makereadme(temp);
result:=temp;
end;

procedure saveMemPath(path:string);
begin
saveReg('MemoryPath',path);
end;

procedure resetOptions;
var
	S: string;
	Reg: TRegistry;
        but0,but1,but2:integer;
        help:string;
begin
but0:=loadButton(0);
but1:=loadButton(1);
but2:=loadButton(2);
help:=loadHelpFile;
	S := GUIDToString(Class_marker);
	Reg := TRegistry.Create;
     try
	Reg.RootKey := HKEY_CURRENT_USER;
	Reg.DeleteKey(barPath + '\' + S + CONFIGPATH);
     finally
        Reg.Free;
     end;
if(but0<>-2)then
  begin
  saveButton(0,but0);
  saveButton(1,but1);
  saveButton(2,but2);
  end;
saveHelpFile(help);
end;

function loadOnlinehelp:String;
begin
result:=loadReg('onlinehelp');
if(result='')then
  result:='http://www.supplets.com';
end;

function getInstallLocation:String;
var
temp:array[0..1023]of char;
t:widestring;
begin
t:=loadReg('instDir');
if(not(fileexists(t+'\Supplets.dll')))then
  begin
  getcurrentdirectory(1023,temp);
  t:=temp;
  end;
result:=t;
end;

//Returns absolute Path of the config exe-file
function getConfigLocation:String;
begin
result:=getInstallLocation+'\setup.exe';
end;

procedure saveButton(what: integer; val:integer);
begin
saveReg('Btn'+inttostr(what),inttostr(val));
end;

function loadButton(what: integer):integer;
var
  tempStr:string;
  tempInt:integer;
begin
tempInt:=-2;
 try
  tempStr:=loadReg('Btn'+inttostr(what));
  if(tempStr<>'')then
    tempInt:=strtoint(tempStr);
 except
  tempInt:=-2;
 end;
Result:=tempInt;
end;

function loadLanguage:integer;
var
  tempStr:string;
begin
tempStr:=loadReg('Lang');
if(tempStr='30000')then
  result:=30000
else
  result:=20000;
end;

procedure saveLanguage(what:integer);
begin
saveReg('Lang',inttostr(what));
end;

function loadMarkerStyle(what:string):MarkerStyle;
var
  tempStr:string;
begin
tempStr:=loadReg(what+StyleDlg_text);
if(tempStr='')then
  Result.textcolor:='#'
else
  Result.textcolor:=tempStr;
tempStr:=loadReg(what+StyleDlg_bg);
if(tempStr='')then
  begin
  if(what=StyleDlg_TeMa)then
    Result.backgroundcolor:='#FFFF66'
  else
    Result.backgroundcolor:='#66FFFF';
  end
else
  Result.backgroundcolor:=tempStr;
tempStr:=loadReg(what+StyleDlg_effect);
if(tempStr='')then
  Result.effect:='none'
else
  Result.effect:=tempStr;
tempStr:=loadReg(what+StyleDlg_dist);
if(tempStr='')then
  Result.distance:='0'
else
  Result.distance:=tempStr;
tempStr:=loadReg(what+StyleDlg_pos);
if(tempStr='')then
  Result.position:='0'
else
  Result.position:=tempStr;
tempStr:=loadReg(what+StyleDlg_bold);
if(tempStr='')then
  Result.bold:=false
else
  Result.bold:=true;
tempStr:=loadReg(what+StyleDlg_italics);
if(tempStr='')then
  Result.italics:=false
else
  Result.italics:=true;
end;

procedure saveMarkerStyle(what:string;style:MarkerStyle);
begin
saveReg(what+StyleDlg_text,style.textcolor);
saveReg(what+StyleDlg_bg,style.backgroundcolor);
saveReg(what+StyleDlg_effect,style.effect);
saveReg(what+StyleDlg_dist,style.distance);
saveReg(what+StyleDlg_pos,style.position);
if(style.bold)then
  saveReg(what+StyleDlg_bold,'1')
else
  saveReg(what+StyleDlg_bold,'');
if(style.italics)then
  saveReg(what+StyleDlg_italics,'1')
else
  saveReg(what+StyleDlg_italics,'');
end;

function loadNoteStyle(what:string):NoteStyle;
var
  tempStr:string;
  tempInt:integer;
begin
tempStr:=loadReg(what+StyleDlg_lineCol);
if(tempStr='')then
  result.linecolor:='#33CC33'
else
  result.linecolor:=tempStr;
tempStr:=loadReg(what+StyleDlg_noteCol);
if(tempStr='')then
  result.notecolor:='#FFFF99'
else
  result.notecolor:=tempStr;
tempStr:=loadReg(what+StyleDlg_lineType);
if(tempStr='')then
  result.linetype:='dashed'
else
  result.linetype:=tempStr;
tempStr:=loadReg(what+StyleDlg_lineWidth);
if(tempStr='')then
  result.linewidth:='1'
else
  result.linewidth:=tempStr;
tempStr:=loadReg(what+StyleDlg_fontName);
if(tempStr='')then
  result.fName:='Arial'
else
  result.fName:=tempStr;
tempStr:=loadReg(what+StyleDlg_fontSize);
try
  tempInt:=strtoint(tempStr);
except
  tempInt:=10;
end;
if(not(tempint in [6..14]))then
  result.fSize:=10
else
  result.fSize:=tempInt;
tempStr:=loadReg(what+StyleDlg_fontItalic);
if(tempStr='false')then
  result.fItalic:=false
else
  result.fItalic:=true;
tempStr:=loadReg(what+StyleDlg_fontBold);
if(tempStr='true')then
  result.fBold:=true
else
  result.fBold:=false;
end;

procedure saveNoteStyle(what:string;style:NoteStyle);
begin
saveReg(what+StyleDlg_lineCol,style.linecolor);
saveReg(what+StyleDlg_noteCol,style.notecolor);
saveReg(what+StyleDlg_lineType,style.linetype);
saveReg(what+StyleDlg_lineWidth,style.linewidth);

saveReg(what+StyleDlg_fontName,style.fName);
saveReg(what+StyleDlg_fontSize,inttostr(style.fSize));
if(style.fBold)then
  saveReg(what+StyleDlg_fontBold,'true')
else
  saveReg(what+StyleDlg_fontBold,'false');
if(style.fItalic)then
  saveReg(what+StyleDlg_fontItalic,'true')
else
  saveReg(what+StyleDlg_fontItalic,'false');
end;

function loadHelpFile:string;
var
  t:widestring;
begin
t:=loadReg('helpfile');
if(fileexists(t))then
  Result:=t
else
  t:=getInstallLocation+'\supplets'+inttostr(loadLanguage)+'.hlp';
if(fileexists(t))then
  begin
  saveHelpFile(t);
  Result:=t;
  end
else
  Result:='';
end;

procedure saveHelpFile(path:string);
begin
saveReg('helpfile',path);
end;

end.
