unit config;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry, ComObj, SuppletOpts, textdata, ComCtrls, ExtCtrls,
  mydialogs;

type
  TForm1 = class(TForm)
    TabControl1: TTabControl;
    Button1: TButton;
    Button3: TButton;
    OKBut: TButton;
    AbortBut: TButton;
    SaveBut: TButton;
    Panel1: TPanel;
    AltColorBut: TButton;
    ColorBut: TButton;
    NotizStyle: TButton;
    ResetAllBut: TButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Button2: TButton;
    Button4: TButton;
    Bevel1: TBevel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Bevel2: TBevel;
    Label3: TLabel;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure AbortButClick(Sender: TObject);
    procedure ColorButClick(Sender: TObject);
    procedure AltColorButClick(Sender: TObject);
    procedure ResetAllButClick(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure NotizStyleClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    procedure loadAll;
    procedure saveAll;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  temastyle:MarkerStyle;
  alttemastyle:MarkerStyle;
  annotestyle:NoteStyle;
  memdir:string;
  lang:integer;

implementation

{$R *.DFM}


procedure registerConfig;
var
	S: string;
	Reg: TRegistry;
begin
	S := GUIDToString(Class_Config);
	Reg := TRegistry.Create;
	try
                Reg.RootKey := HKEY_LOCAL_MACHINE;
                Reg.OpenKey(ExtensionsPath +'\'+S,true);
                Reg.WriteString('CLSID','{1FBA04EE-3024-11d2-8F1F-0000F87ABD16}');
                Reg.WriteString('MenuText',CONFIG_MENUTEXT);
                Reg.WriteString('MenuStatusBar',CONFIG_STATUSTEXT);
                Reg.WriteString('Exec',getConfigLocation);
                Reg.CloseKey;
 	finally
		Reg.Free;
	end;
end;

procedure unregisterConfig;
var
	S: string;
	Reg: TRegistry;
begin
	S := GUIDToString(Class_Config);
	Reg := TRegistry.Create;
	try
                Reg.RootKey := HKEY_LOCAL_MACHINE;
                Reg.DeleteKey(ExtensionsPath +'\'+S);
 	finally
		Reg.Free;
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
registerConfig;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
unregisterConfig;
end;

procedure TForm1.loadAll;
begin
//load styles....
temastyle:=loadMarkerStyle(StyleDlg_TeMa);
alttemastyle:=loadMarkerStyle(StyleDlg_altTeMa);
annoteStyle:=loadNoteStyle(StyleDlg_Note);
SaveBut.enabled:=false;
memdir:=loadMemPath;
edit1.text:=memdir;
lang:=loadLanguage;
edit2.text:=loadOwner(lang);
if(lang=30000)then
  ComboBox1.text:='Deutsch'
else
  ComboBox1.text:='English';
Form1.caption:=loadLangRes(100+lang);
TabControl1.Tabs.Strings[0]:=loadLangRes(101+lang);
TabControl1.Tabs.Strings[1]:=loadLangRes(102+lang);
OKBut.Caption:=loadLangRes(103+lang);
AbortBut.Caption:=loadLangRes(104+lang);
SaveBut.Caption:=loadLangRes(105+lang);
ResetAllBut.Caption:=loadLangRes(106+lang);
ColorBut.Caption:=loadLangRes(107+lang);
AltColorBut.Caption:=loadLangRes(108+lang);
NotizStyle.Caption:=loadLangRes(109+lang);
Label1.Caption:=loadLangRes(110+lang);
Button4.Caption:=loadLangRes(111+lang);
Label2.Caption:=loadLangRes(112+lang);
label3.Caption:=loadLangRes(113+lang);
end;

procedure TForm1.saveAll;
begin
//save styles...
saveMarkerStyle(StyleDlg_TeMa,temaStyle);
saveMarkerStyle(StyleDlg_altTeMa,altTemaStyle);
saveNoteStyle(StyleDlg_Note,annotestyle);
SaveBut.enabled:=false;
SendNotifyMessage(HWND_BROADCAST,RegisterWindowMessage(WM_UPDATEOPTIONS),0,0);
saveMemPath(edit1.text);
saveOwner(edit2.text);
if(ComboBox1.text='Deutsch')then
  saveLanguage(30000)
else
  saveLanguage(20000);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
HelpFile:=loadHelpFile;
loadAll;
Panel1.Visible:=true;
Panel2.Visible:=false;
panel2.left:=2;
panel1.left:=8;
end;

procedure TForm1.SaveButClick(Sender: TObject);
begin
saveAll;
loadAll;
end;

procedure TForm1.OKButClick(Sender: TObject);
begin
saveAll;
Close;
end;

procedure TForm1.AbortButClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.ColorButClick(Sender: TObject);
var
  x:TMarkerStyleDialog;
begin
x:=TMarkerStyleDialog.Create(200,temaStyle,Self.Handle,helpfile);
if(x.execute<>0)then
  begin
  //copy values here since dialog was quitted with 'OK'
  temastyle:=x.vals;
  SaveBut.enabled:=true;
  end;
//ColorDialog1.execute;
x.free;
end;

procedure TForm1.AltColorButClick(Sender: TObject);
var
  x:TMarkerStyleDialog;
begin
x:=TMarkerStyleDialog.Create(200,altTemaStyle,Self.Handle,helpfile);
if(x.execute<>0)then
  begin
  //copy values here since dialog was quitted with 'OK'
  alttemastyle:=x.vals;
  SaveBut.enabled:=true;
  end;
//ColorDialog1.execute;
x.free;
end;

procedure TForm1.ResetAllButClick(Sender: TObject);
begin
if(MessageDlg('Alle Einstellungen zurcksetzten? Dies kann nicht rckgngig gemacht werden!',mtConfirmation,[mbOk,mbCancel], 0)=mrOK)then
  begin
  resetOptions;
  loadAll;
  SaveBut.enabled:=false;
  end;
end;

procedure TForm1.TabControl1Change(Sender: TObject);
begin
case TabControl1.TabIndex of
  0:
    begin
    Panel1.visible:=true;
    Panel2.visible:=false;
    end;
  1:
    begin
    Panel1.visible:=false;
    Panel2.visible:=true;
    end;
  end;
end;

procedure TForm1.NotizStyleClick(Sender: TObject);
var
  x:TNoteStyleDialog;
begin
//MessageDlg('annoteStyle: '+annoteStyle.linecolor+' '+annoteStyle.notecolor+' '+annoteStyle.linetype+' '+annoteStyle.linewidth,mtInformation,[mbOk], 0);
x:=TNoteStyleDialog.Create(300,annoteStyle,Self.Handle,helpfile);
if(x.execute<>0)then
  begin
  //copy values here since dialog was quitted with 'OK'
  annotestyle:=x.vals;
  SaveBut.enabled:=true;
  end;
x.free;
//MessageDlg('annoteStyle: '+annoteStyle.linecolor+' '+annoteStyle.notecolor+' '+annoteStyle.linetype+' '+annoteStyle.linewidth,mtInformation,[mbOk], 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
WinExec(PChar('explorer '+edit1.text),SW_SHOW);
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
if(not(fileexists(edit1.text+'\readme.txt')))then
  try
  makereadme(edit1.text);
  except
    MessageDlg('Dieses Verzeichnis existiert nicht!',mtError,[mbOk], 0);
    edit1.text:=memdir;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
tempx:PChar;
begin
getmem(tempx,1023);
strpcopy(tempx,'explorer '+edit1.text);
winexec(tempx,SW_SHOW);
freemem(tempx);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  SaveBut.enabled:=true;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  SaveBut.enabled:=true;
end;

end.
