unit myCol;

interface

uses
  Dialogs, Messages, SysUtils, barUtil,fEnum,SuppletOpts,
           Windows, ActiveX, ComObj, ComServ, myDialogs,
            Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ,CommCtrl,Classes;

type

myDoc=class;
aNote=class(TObject)
  private
  public
    timestamp:double;
    ownerstamp:wideString;
    bookmark:wideString;
    location:wideString;
    markedText:wideString;
    refBoundRect:tRect;
    lastPos:tRect;
    id:integer;
    text:wideString;
    styleClass:wideString;
    holder:myDoc;
    myNote:tNote;//only used when inBar!!!
    constructor create;
    procedure show;
    procedure visUninited;
    procedure free; overload;
    procedure scrollIntoView(top:boolean);
    procedure delete;
    procedure selfLocate(body:IHTMLBodyElement);
    function getbefore:string;
    function getStamp:wideString;
  end;
myDoc=class(TObject)
  private
    nextID:integer;
    function getNextID:integer;
  public
    body:IHTMLElement2;
    clientRect:TRect;
    lastScrollPos:integer;
    docName:String;
    notes:TList;
    visNote:TNote;
    owner:pointer;
    constructor create(ownpar:pointer);
    function alreadyExists(bookmark:wideString):boolean;
    procedure loadFromStrings(input:TStringList);
    procedure incorporateNotes(forURL:wideString;browser:IWebBrowser2);
    procedure save(cURL:string;destroy:boolean;all:boolean);
    procedure loadMain(what:string);
    function getPredNote(i:integer):tNote;
    function getSuccNote(i:integer):tNote;
    procedure sort;
    procedure updateBodyRect;
    function newNote(cURL,MarkerClass:string;bookmark:widestring):aNote;
    procedure load(what:string);
    procedure add(what:aNote);
    procedure show(what:IHTMLElement); overload;
    procedure show(what:integer); overload;
    function findNote(theID:integer):aNote;
    procedure free; overload;
    procedure updateBarNotes;
    procedure updateAllNotePos;
    function getOuterBound(id:integer):TRect;
  end;

function getStClass(StyleClass:wideString):wideString;
function getID(input:wideString):integer;
function getBody(forFrame:IWebBrowser):IHTMLElement2;
function min(a,b:integer):integer;
function max(a,b:integer):integer;

implementation

uses savo,mark;

//begin Class aNote
constructor aNote.create;
begin
refBoundRect.Top:=0;
myNote:=nil;
end;

function fixSpace(var input:wideString;i:integer):integer;
begin
if(input[i]=' ')then
  begin
  delete(input,i,1);
  insert('&nbsp',input,i);
  result:=4;
  end
else
  result:=0;
end;

function aNote.getBefore:String;
begin
if(getStClass(styleClass)<>'NOTE')then
  result:='<SPAN class="'+styleClass+'" id=s'+inttostr(id)+' title="'+getStamp+'">'
else
  result:='<SPAN class="'+styleClass+'" id=s'+inttostr(id)+'>';
end;

procedure aNote.selfLocate(body:IHTMLBodyElement);
var
myRange:IHTMLTxtRange;
success:boolean;
before,after:wideString;
begin
success:=boolean(false);
myRange:=body.createTextRange;
try
//MessageDlg('trying locate begin: '+bookmark,mtError,[mbOk], 0);
//myRange.moveToElementText(body as IHTMLElement);
//bookmark:=myRange.getBookmark;
if(myRange.moveToBookmark(bookmark))then
  begin
  success:=boolean(true)
  end;
//else
//  MessageDlg('not found via movetoBookmark',mtError,[mbOk], 0);
except
 MessageDlg('internal error 241',mtError,[mbOk], 0);
end;
if(not(success))then
  begin
//  MessageDlg('trying findText',mtError,[mbOk], 0);
  myRange.moveToElementText(body as IHTMLElement);
  if(myRange.findText(markedText,0,0))then
    success:=boolean(true);
//  else
//    MessageDlg('not found in:'+myRange.Get_text,mtError,[mbOk], 0);
  end;
if(success)then
  begin
  before:=getbefore;
  after:='</SPAN>';
  pasteStyle(before,after,myRange);
  end
else
  MessageDlg('The annotation made on '+char(13)+char(10)+'"'+markedText+'"'+char(13)+char(10)+' could not be restored, probably due to changes in the content of the page.',mtInformation,[mbOk], 0);
end;

procedure aNote.delete;
var
  ElemColByID:IHTMLElementCollection;
  ElemEnumUnk:IUnknown;
  en:IEnumVariant;
  els:OleVariant;
  OneElem:IDispatch;
  TheElem:IHTMLElement;
  i:integer;
  z:IhtmlDocument3;
  cF:IWebBrowser2;
  temp:wideString;
begin
if(myNote<>nil)then
  myNote.uninit;
if(holder.visNote<>nil)and(holder.visNote.ID=id)then
  holder.visNote.unInit;
try
cF:=tMarker(holder.owner).getBrowser(location);
if(cF=nil)then
  begin
  MessageDlg('internal error 191',mtError,[mbOk], 0);
  exit;
  end;
cF.Document.QueryInterface(IID_IHtmlDocument3,z);
ElemColByID:=z.getElementsByName('s'+inttostr(id));
ElemEnumUnk:=ElemColByID.Get__newEnum;
ElemEnumUnk.QueryInterface(IEnumVariant,en);
//en.reset;
while(en.Next(1,els,nil)=S_OK)do
    begin
    OneElem:=els;
    if(SUCCEEDED(OneElem.QueryInterface(IID_IHTMLElement,theElem)))then
      begin
      temp:=theElem.Get_innerHTML;
      fixSpace(temp,1);
      theElem.Set_outerHTML(temp);
      theElem._Release;
      end;
    end;
//z._Release; //problem?
en._Release;
//???   cF._Release;
//end;
except
MessageDlg('internal error 5: getting IDs',mtError,[mbOk], 0);
end;
Broadcast(tMarker(holder.owner).rebar,WM_SUPPLETDELNOTE,integer(self));
styleClass:='xxxxxxxx';
i:=holder.notes.IndexOf(self);
if(holder.getSuccNote(i)<>nil)then
  holder.getSuccNote(i).adjustSize(-1,-1,-1,-1);
holder.notes.Delete(i);
//  MessageDlg('end del',mtError,[mbOk], 0);
holder.sort;
free;
end;

procedure aNote.visUninited;
begin
if(myNote<>nil)then
  begin
  text:=myNote.Text;
  myNote.free;
  myNote:=nil;
  end
else
  if(holder.visNote<>nil)then
    begin
    text:=holder.visNote.Text;
    holder.visNote.free;
    holder.visNote:=nil;
    end;
end;

procedure aNote.free;
begin
inherited free;
end;

function getStClass(StyleClass:wideString):wideString;
begin
result:=copy(StyleClass,1,4);
end;

function myDoc.getOuterBound(id:integer):TRect;
var
  overallBound:tRect;
  temp2:IHTMLRect;
  ElemColByID:IHTMLElementCollection;
  ElemEnumUnk:IUnknown;
  en:IEnumVariant;
  els:OleVariant;
  OneElem:IDispatch;
  TheElem:IHTMLElement2;
  z:IHTMLDocument3;
  cF:IWebBrowser2;
  FrameXY,TopXY:TPoint;
begin
overallBound.Left:=0;
overallBound.Top:=0;
overallBound.Right:=0;
overallBound.Bottom:=0;
if(getStClass(findNote(id).styleClass)<>'NOTE')then
  exit;
overallBound.Left:=9999;
overallBound.Top:=9999;
try
cF:=tMarker(owner).getBrowser(findNote(id).location);
if(cF=nil)then
  begin
  MessageDlg('internal error 191',mtError,[mbOk], 0);
  exit;
  end;
cF.Document.QueryInterface(IID_IHtmlDocument3,z);
en:=nil;
theElem:=nil;
ElemColByID:=z.getElementsByName('s'+inttostr(id));
ElemEnumUnk:=ElemColByID.Get__newEnum;
ElemEnumUnk.QueryInterface(IEnumVariant,en);
en.reset;
while(en.Next(1,els,nil)=S_OK)do
    begin
    OneElem:=els;
    if(SUCCEEDED(OneElem.QueryInterface(IID_IHTMLElement2,theElem)))then
      begin
      temp2:=theElem.getBoundingClientRect();
      if(temp2.Get_left<overallBound.Left)then
        overallBound.Left:=temp2.Get_left;
      if(temp2.Get_top<overallBound.Top)then
        overallBound.Top:=temp2.Get_top;
      if(temp2.Get_right>overallBound.Right)then
        overallBound.Right:=temp2.Get_right;
      if(temp2.Get_bottom>overallBound.Bottom)then
        overallBound.Bottom:=temp2.Get_bottom;
      theElem._Release;
      end;
    end;
//problem?  z._Release;
en._Release;
//???   cF._Release;
except
MessageDlg('internal error 7: getting IDs',mtError,[mbOk], 0);
end;
if(overallBound.right<>0)then
  dec(overallBound.right,overallBound.left);
if(overallBound.Bottom<>0)then
  dec(overallBound.Bottom,overallBound.top);
FrameXY:=frameEnum.getScreenPos(cF);
TopXY:=frameEnum.getScreenPos(tMarker(owner).iFrame);
inc(overallBound.left,FrameXY.x);
dec(overallBound.left,TopXY.x);
inc(overallBound.Top,FrameXY.y);
dec(overallBound.Top,TopXY.y);

//MessageDlg('screenXY '+inttostr(FrameXY.x)+'##'+inttostr(FrameXY.y),mtError,[mbOk], 0);
//MessageDlg('topXY '+inttostr(topXY.x)+'##'+inttostr(topXY.y),mtError,[mbOk], 0);
dec(overallBound.Top,20);
result:=overallBound;
end;

function min(a,b:integer):integer;
begin
if(a<b)then
  result:=a
else
  result:=b;
end;

function max(a,b:integer):integer;
begin
if(a>b)then
  result:=a
else
  result:=b;
end;

function getGoodShowPos(location:wideString;id,sizeX,sizeY:integer;par:tMarker):tRect;
var
  temp,overallBound:tRect;
  temp2:IHTMLRect;
  ElemColByID:IHTMLElementCollection;
  ElemEnumUnk:IUnknown;
  en:IEnumVariant;
  els:OleVariant;
  iDisp,OneElem:IDispatch;
  TheElem:IHTMLElement2;
  currentPt:tPoint;
  z:IHTMLDocument3;
  cF:IWebBrowser2;
  xOff,yOff:integer;
  xy:TPoint;
begin
temp.Left:=0;
temp.Top:=0;
getCursorPos(currentPt);
getwindowrect(par.docWind,temp);

overallBound.Left:=9999;
overallBound.Top:=9999;
overallBound.Right:=0;
overallBound.Bottom:=0;
xOff:=0;yOff:=0;
try
cF:=par.getBrowser(location);
if(cF=nil)then
  begin
  MessageDlg('internal error 192',mtError,[mbOk], 0);
  exit;
  end;
iDisp:=cF.Get_Document;
if(not(SUCCEEDED(iDisp.QueryInterface(IID_IHtmlDocument3,z))))then
  begin
  exit;
  MessageDlg('internal error 189',mtError,[mbOk], 0);
  end;

xy:=frameEnum.getScreenPos(cF);
xOff:=xy.x;
yOff:=xy.y;
xy:=frameEnum.getScreenPos(par.iFrame);
dec(xOff,xy.x);
dec(yOff,xy.y);
//MessageDlg('x: '+inttostr(xOff)+' y'+inttostr(yOff),mtError,[mbOk], 0);

en:=nil;
theElem:=nil;
ElemColByID:=z.getElementsByName('s'+inttostr(id));
ElemEnumUnk:=ElemColByID.Get__newEnum;
if(SUCCEEDED(ElemEnumUnk.QueryInterface(IEnumVariant,en)))then
  begin
  while(en.Next(1,els,nil)=S_OK)do
    begin
    OneElem:=els;
    if(SUCCEEDED(OneElem.QueryInterface(IID_IHTMLElement2,theElem)))then
      begin
      temp2:=theElem.getBoundingClientRect();
      if(temp2.Get_left<overallBound.Left)then
        overallBound.Left:=temp2.Get_left;
      if(temp2.Get_top<overallBound.Top)then
        overallBound.Top:=temp2.Get_top;
      if(temp2.Get_right>overallBound.Right)then
        overallBound.Right:=temp2.Get_right;
      if(temp2.Get_bottom>overallBound.Bottom)then
        overallBound.Bottom:=temp2.Get_bottom;
      theElem._Release;
      end;
    end;
  en._Release;
  end;
//problem?  z._Release;
//???   cF._Release;
except
MessageDlg('internal error 27: getting IDs',mtError,[mbOk], 0);
end;

result.left:=temp.left;
result.top:=temp.top;
//convert from client to screen coordinates:
inc(overallBound.Top,temp.Top+2+yOff);
inc(overallBound.Left,temp.Left+2+xOff);
inc(overallBound.Right,temp.Left+2+xOff);
inc(overallBound.Bottom,temp.Top+2+yOff);

//cut invisible parts:
overallBound.Top:=max(temp.top,overallBound.Top);
overallBound.Left:=max(temp.left,overallBound.Left);
overallBound.Bottom:=min(temp.Bottom,overallBound.Bottom);
overallBound.Right:=min(temp.Right,overallBound.Right);

if(abs(overallBound.Top-currentPt.y)<abs(overallBound.Bottom-currentPt.y))then
begin //prefer to show note above Element
 if(overallBound.Top-sizeY-10>0)then
  result.top:=overallBound.Top-sizeY-10
  else
    result.top:=currentPt.y;//max(0,min(overallBound.Top,currentPt.y));
end else
begin //prefer to show note below Element
//MessageDlg(inttostr(overallBound.Top)+' '+inttostr(overallBound.Bottom)+' '+inttostr(getsystemMetrics(SM_CYFULLSCREEN))+' ',mtInformation,[mbOk], 0);
 if(overallBound.Bottom+sizeY+10<getsystemMetrics(SM_CYFULLSCREEN))then
  result.top:=overallBound.Bottom+10
  else
    result.top:=currentPt.y-sizeY;//min(getsystemMetrics(SM_CYFULLSCREEN)-sizeY,max(overallBound.Bottom-sizeY,currentPt.y-sizeY));
end;
if(result.top>overallBound.Top)and(result.top<overallBound.Bottom)then
 begin //note is inside Element so try to move left or right beside Elem
 if(overallBound.Left-sizeX-10>0)then
  result.Left:=overallBound.Left-sizeX-10
  else
  if(overallBound.Right+sizeX+10<getsystemMetrics(SM_CXFULLSCREEN))then
    result.left:=overallBound.Right+10
    else
      if(currentPt.x>getsystemMetrics(SM_CXFULLSCREEN)div 2)then
        result.left:=min(currentPt.x-(sizeX div 2),getsystemMetrics(SM_CXFULLSCREEN)-sizeX)
      else
        result.left:=max(currentPt.x-(sizeX div 2),0);
 end else
 begin //note is above or below Elem so try to go as close to Cursorpos as possible
 if(currentPt.x-sizeX>0)then
  result.Left:=currentPt.x-sizeX
  else
  if(currentPt.x+sizeX<getsystemMetrics(SM_CXFULLSCREEN))then
    result.left:=currentPt.x
    else
      if(currentPt.x>getsystemMetrics(SM_CXFULLSCREEN)div 2)then
        result.left:=min(currentPt.x-(sizeX div 2),getsystemMetrics(SM_CXFULLSCREEN)-sizeX)
      else
        result.left:=max(currentPt.x-(sizeX div 2),0);
 end;
result.right:=sizeX;
result.Bottom:=sizeY;
end;

function aNote.getStamp:wideString;
begin
if(ownerstamp<>loadOwner(tmarker(holder.owner).language))then
  result:=ownerstamp+', '
else
  result:='';
result:=result+formatdatetime('ddddd" "t',timestamp);
end;

procedure aNote.show;
var
  pos,pos2:TRect;
begin
if(getStClass(styleClass)<>'NOTE')then
  exit;
if(tMarker(holder.owner).barvisible)then
  begin
  if(myNote<>nil)then
    exit; //scroll the note into view
  myNote:=TNote.Create(id,getStamp,text,tMarker(holder.owner).noteFont,WebColorToRGB(tMarker(holder.owner).noteMarker.notecolor),boolean(true),tMarker(holder.owner).barWind,self);
  if(lastPos.Top=0)and(lastPos.Bottom=0)then
    holder.sort;
  getClientRect(tMarker(holder.owner).barWind,pos);
  pos2:=holder.getOuterBound(id);
//  myNote.wantedTop:=pos2.Top;
  pos.Left:=2;
  dec(pos.Right,4);
  pos.Top:=pos2.Top;
//  lastPos.Top:=0;
  if(lastPos.Bottom<10)then
    pos.Bottom:=max(min(pos2.Bottom,400),200)
  else
    pos.Bottom:=lastPos.Bottom;
  myNote.show(pos);
//  myNote.adjustSize(-1,-1,-1,-1);
  aNote(holder.notes.items[0]).myNote.adjustSize(-1,-1,-1,-1);
  end
else  //bar hidden, so show in a free note window
  begin
  if(holder.visNote=nil)or(holder.visnote.id<>id)then
    begin
    if(holder.visNote<>nil)and(holder.visnote.id<>id)then
      holder.visNote.uninit;
    holder.visNote:=TNote.Create(id,getStamp,text,tMarker(holder.owner).noteFont,WebColorToRGB(tMarker(holder.owner).noteMarker.notecolor),boolean(false),tMarker(holder.owner).myparentWind,self);
    if(lastPos.Right=0)then
      pos.Right:=200
    else
      pos.Right:=lastPos.Right;
    if(lastPos.Bottom=0)then
      pos.Bottom:=200
    else
      pos.Bottom:=lastPos.Bottom;
    pos:=getGoodShowPos(location,id,pos.right,pos.bottom,tMarker(holder.owner));
    holder.visNote.show(pos);
    end
  else
    begin
    Exit;
    //following lines will move note to pos near cursor
    getClientRect(holder.visNote.ownWind,pos);
    pos:=getGoodShowPos(location,id,pos.right,pos.bottom,tMarker(holder.owner));
    holder.visNote.adjustSize(pos.Left,pos.Top,-1,-1);
    end;
  end;
end;

procedure aNote.scrollIntoView(top:boolean);
var
  overallBound:tRect;
  temp2:IHTMLRect;
  ElemColByID:IHTMLElementCollection;
  ElemEnumUnk:IUnknown;
  en:IEnumVariant;
  els:OleVariant;
  OneElem:IDispatch;
  TheElem:IHTMLElement2;
  extremeTopElem:IHTMLElement;
  extremeBottomElem:IHTMLElement;
  z:IHTMLDocument3;
  cF:IWebBrowser2;
begin
overallBound.Left:=9999;
overallBound.Top:=9999;
overallBound.Right:=0;
overallBound.Bottom:=0;
try
cF:=tMarker(holder.owner).getBrowser(location);
if(cF=nil)then
  begin
  MessageDlg('internal error 192',mtError,[mbOk], 0);
  exit;
  end;
if(not(SUCCEEDED(cF.Document.QueryInterface(IID_IHtmlDocument3,z))))then
  begin
  exit;
  MessageDlg('internal error 189',mtError,[mbOk], 0);
  end;
en:=nil;
extremeTopElem:=nil;
extremeBottomElem:=nil;
theElem:=nil;
ElemColByID:=z.getElementsByName('s'+inttostr(id));
ElemEnumUnk:=ElemColByID.Get__newEnum;
ElemEnumUnk.QueryInterface(IEnumVariant,en);
en.reset;
while(en.Next(1,els,nil)=S_OK)do
    begin
    OneElem:=els;
    OneElem.QueryInterface(IID_IHTMLElement2,theElem);
    temp2:=theElem.getBoundingClientRect();
    if(temp2.Get_top<overallBound.Top)then
      begin
      overallBound.Top:=temp2.Get_top;
//???         extremeTopElem._Release;
      OneElem.QueryInterface(IID_IHTMLElement,extremeTopElem);
      end;
    if(temp2.Get_bottom>overallBound.Bottom)then
      begin
      overallBound.Bottom:=temp2.Get_bottom;
//???         extremeBottomElem._Release;
      OneElem.QueryInterface(IID_IHTMLElement,extremeBottomElem);
      end;
//???       theElem._Release;
    end;
//problem?  z._Release;
en._Release;
//???   cF._Release;
except
MessageDlg('internal error 6: getting IDs',mtError,[mbOk], 0);
exit;
end;
if(top)then
  extremeTopElem.scrollIntoView(top)
else
  extremeBottomElem.scrollIntoView(top);
//???   extremeBottomElem._Release;
//???   extremeTopElem._Release;
end;
//end class aNote

function getID(input:wideString):integer;
begin
input:=copy(input,2,99);
try
  result:=strtoint(input);
except
  result:=0;
end;
end;

function getBody(forFrame:IWebBrowser):IHTMLElement2;
var
  x:IDispatch;
  x2:IHTMLDocument2;
  y:IHtmlElement;
  y2:IHTMLElement2;
begin
result:=nil;
if(forFrame=nil)then
  exit;
x:=forFrame.Get_Document;
if(SUCCEEDED(x.QueryInterface(IID_IHTMLdocument2,x2)))then
  begin
  y:=x2.Get_body;
  if(SUCCEEDED(y.QueryInterface(IID_IHTMLElement2,y2)))then
    result:=y2;
  end;
{try
for i:=0 to tMarker(par).FrameDocs.count-1 do
begin
en:=nil;
theElem:=nil;
theElem2:=nil;
IHTMLDocument2(tMarker(par).FrameDocs.items[i]).QueryInterface(IID_IHtmlDocument3,z);
ElemColByID:=z.getElementsByTagName('BODY');
ElemEnumUnk:=ElemColByID.Get__newEnum;
ElemEnumUnk.QueryInterface(IEnumVariant,en);
en.reset;
while(en.Next(1,els,nil)=S_OK)do
    begin
    OneElem:=els;
    OneElem.QueryInterface(IID_IHTMLElement,theElem);
    if(theElem.Get_tagName='BODY')then
      begin
      theElem.QueryInterface(IID_IHtmlElement2,theElem2);
      ComRelease(pointer(theElem));
      break;
      end;
//    theElem.Set_outerHTML(theElem.Get_innerHTML);
    ComRelease(pointer(theElem));
    end;
//MessageDlg('scroll: '+inttostr(bound.Top)+' '+inttostr(bound.Bottom),mtInformation,[mbOk], 0);
ComRelease(pointer(z));
ComRelease(pointer(en));
end; //for
except
MessageDlg('internal error 95: getting IDs',mtError,[mbOk], 0);
end;
ComRelease(pointer(en));
result:=theElem2;}
end;

//begin class myDoc
function myDoc.getPredNote(i:integer):tNote;
begin
result:=nil;
notes.Pack;
if(i<1)or(i>notes.count)then
  exit;
repeat
dec(i);
until(i<0)or(getStClass(aNote(notes.items[i]).styleClass)='NOTE');
if(i>=0)then
  result:=aNote(notes.items[i]).myNote;
end;

function myDoc.getSuccNote(i:integer):tNote;
begin
result:=nil;
notes.Pack;
if(i<-1)or(i>notes.count-2)then
  exit;
repeat
inc(i);
until(i>notes.count-1)or(getStClass(aNote(notes.items[i]).styleClass)='NOTE');
if(i<notes.count)then
  result:=aNote(notes.items[i]).myNote;
end;

procedure myDoc.updateAllNotePos;
var
i:integer;
begin
notes.pack;
for i:=0 to notes.count-1 do
  if(aNote(notes.items[i]).myNote<>nil)then
    aNote(notes.items[i]).myNote.savePos;
end;

procedure myDoc.updateBodyRect;
var
  bodyrect:tRect;
  TheElem2:IHTMLElement2;
begin
bodyRect.Left:=2;
bodyRect.Top:=2;
bodyRect.Right:=2;
bodyRect.Bottom:=2;
try
  if(body=nil)and(notes.count>0)then
    body:=getBody(TMarker(owner).getBrowser(aNote(notes.items[notes.count-1]).location));
  TheElem2:=body;
except
  body:=nil;
  TheElem2:=nil;
end;
if(theElem2<>nil)then
      begin
      bodyRect.Left:=theElem2.Get_scrollLeft;
      bodyRect.Top:=theElem2.Get_scrollTop;
      bodyRect.Right:=theElem2.Get_scrollWidth;
      bodyRect.Bottom:=theElem2.Get_scrollHeight;
      end;
clientRect:=bodyRect;
end;

function posDiff(Item1, Item2: Pointer): Integer;
begin
result:=aNote(Item1).refBoundRect.Top-aNote(Item2).refBoundRect.Top;
end;

procedure myDoc.sort;
var
 i:integer;
begin
notes.pack;
for i:=0 to notes.count-1 do
  aNote(notes.Items[i]).refBoundRect:=getOuterBound(aNote(notes.Items[i]).id);
notes.Sort(posDiff);
end;

procedure myDoc.updateBarNotes;
begin
if(lastScrollPos<>-1)then
  lastScrollPos:=clientRect.top
else
  lastScrollPos:=0;
updateBodyRect;
if(not(isWindow(tMarker(owner).barwind)))then
  exit;
if(lastScrollPos<>clientRect.top)then
  begin
  ScrollWindowEx(tMarker(owner).barwind,0,lastScrollPos-clientRect.top,nil,nil,
               0,nil,SW_SCROLLCHILDREN or SW_INVALIDATE or SW_ERASE);
//  lastScrollPos:=clientRect.top;
  end;
end;

procedure myDoc.show(what:IHTMLElement);
begin
show(getID(what.Get_id));
end;

function myDoc.findNote(theID:integer):aNote;
var
 i:integer;
begin
notes.pack;
for i:=0 to notes.count-1 do
  if(aNote(notes.Items[i]).id=theID)then
    begin
    result:=aNote(notes.Items[i]);
    exit;
    end;
result:=nil;
end;

procedure myDoc.show(what:integer);
var
temp:aNote;
begin
temp:=findNote(what);
if(temp<>nil)then
  temp.show;
end;

function myDoc.alreadyExists(bookmark:wideString):boolean;
var
i:integer;
begin
notes.pack;
result:=boolean(false);
for i:=0 to notes.count-1 do
 if(aNote(notes.Items[i]).bookmark=bookmark)then
  begin
  result:=boolean(true);
  exit;
  end
end;

function myDoc.newNote(cURL,MarkerClass:string;bookmark:widestring):aNote;
var
  nNote:aNote;
begin
nNote:=aNote.Create;
nNote.bookmark:=bookmark;
nNote.id:=getNextID;
nNote.timestamp:=now;
nNote.ownerstamp:=loadOwner(tmarker(owner).language);
nNote.styleClass:=MarkerClass;
nNote.holder:=self;
if(notes<>nil)then
  notes.add(pointer(nNote))
else
  MessageDlg('internal error 176',mtError,[mbOk], 0);
nNote.location:=cURL;
nNote.lastPos.Left:=0;
nNote.lastPos.Top:=0;
nNote.lastPos.Right:=0;
nNote.lastPos.Bottom:=0;
result:=nNote;
Broadcast(tMarker(owner).rebar,WM_SUPPLETNEWNOTE,integer(@nNote));
end;

//saves notes to disk, if destroy is set afterwards the notes
//are deleted (i.e. for moving to another page), if all is not
//set only those notes are included which have the same URL as
//cURL (i.e. not good for frame pages)
procedure myDoc.save(cURL:string;destroy:boolean;all:boolean);
var
temp:TList;
i:integer;
begin
temp:=TList.Create;
if(notes<>nil)then
  begin
  notes.pack;
  for i:=0 to notes.count-1 do
    if((all)or(aNote(notes.items[i]).location=cURL))then
      begin
      if(destroy)then
       Broadcast(tMarker(owner).rebar,WM_SUPPLETDELNOTE,integer(notes.items[i]));
      temp.Add(notes.items[i]);
      if(aNote(notes.items[i]).myNote<>nil)then
       if(destroy)then
        aNote(notes.items[i]).myNote.uninit
       else
        aNote(notes.items[i]).myNote.updatetext;
      if(visNote<>nil)and(visNote.ID=aNote(notes.items[i]).id)then
       if(destroy)then
        visNote.uninit
       else
        visNote.updateText;
      notes.items[i]:=nil;
      end;
  notes.pack;
//???  MessageDlg('saving for: '+Curl+' '+inttostr(notes.count),mtError,[mbOk], 0);
  end;
temp.pack;
savo.save(cURL,temp);
if(temp.count>0)then
  if(destroy)then
   for i:=0 to temp.count-1 do
    aNote(temp.items[i]).free;
temp.free;
end;

procedure myDoc.incorporateNotes(forURL:wideString;browser:IWebBrowser2);
var
i:integer;
web2:IWebBrowser2;
idisp:IDispatch;
doc2:IHTMLDocument2;
elem:IHTMLElement;
body:IHTMLBodyElement;
begin
if(notes=nil)then
  exit;
notes.pack;
if(Browser=nil)then
  web2:=tMarker(owner).getBrowser(forURL)
else
  web2:=Browser;
if(web2=nil)then
  begin
  MessageDlg('internal error 261',mtError,[mbOk], 0);
  exit;
  end;
idisp:=web2.Get_Document;
if(SUCCEEDED(idisp.QueryInterface(IID_IHTMLDocument,doc2)))then
 begin
 elem:=doc2.Get_body;
 if(SUCCEEDED(elem.QueryInterface(IID_IHTMLBodyElement,body)))then
   for i:=0 to notes.count-1 do
    if(aNote(notes.items[i]).location=forURL)then
     begin  //this note was loaded by myDoc.load and has to be shown now.
     aNote(notes.items[i]).selfLocate(body);
     end;
 end;
end;


procedure myDoc.loadMain(what:string);
begin
body:=nil;
nextID:=1;
load(what);
end;

procedure myDoc.loadFromStrings(input:TStringList);
//var
//i:integer;
begin
//for i:=0 to input.count-1 do
//  MessageDlg(input.Strings[i],mtError,[mbOk], 0);
savo.loadnotes(self,input);
end;

procedure myDoc.load(what:string);
var
temp:integer;
begin
docName:=what; //shit
body:=nil;
//if(body<>nil)then
//  body._Release;
updateBarNotes;
//MessageDlg('go',mtError,[mbOk], 0);
temp:=savo.load(what,self);
//if(not(already old data safed))then create new:
end;

function myDoc.getNextID:integer;
begin
result:=nextID;
inc(nextID);
end;

procedure myDoc.add(what:aNote);
begin
notes.Add(@what);
end;

procedure myDoc.free();
var
i:integer;
begin
if(notes<>nil)then
  begin
  notes.pack;
  for i:=0 to notes.count-1 do
    aNote(notes.Items[i]).Free;
//  if(body<>nil)then
//    body._Release;
  end;
inherited free;
end;

constructor myDoc.create(ownpar:pointer);
begin
inherited Create;
docName:='';
lastScrollPos:=-1;
clientRect.Top:=0;
notes:=TList.Create();
nextID:=1;
body:=nil;
owner:=ownpar; //always needs casting to TMarker!!!
end;

end.
